<?php
/*
 * Name:      Timesheet
 * Directory: timesheet
 * Version:   2.0.
 * Type:      user
 * UI Name:   Timesheet
 * UI Icon:   timesheet.png
 */

/*
 * Copyright (C) 2007-2014, M2X BV
 *
 * Authors: Jean-Paul Saman
 *
 * This file is based upon configure.php from HelpDesk dotProject module
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 *****************************************************************************/

if (!defined('W2P_BASE_DIR')) {
        die('You should not access this file directly.');
}

// deny all but system admins
$canEdit = canEdit('system');
if (!$canEdit) {
        $AppUI->redirect(ACCESS_DENIED);
}

$AppUI->savePlace();

// TODO Remove queries from this file
$config = array();
$q = new w2p_Database_Query;
if (isset($_POST['forcesubmit']) && isset($_POST['submit'])) {
    $q->addTable('timesheet_config');
    $q->addUpdate('timesheet_config', 'timesheet_approval_by');
    $q->addUpdate('timesheet_value', $_POST['timesheet_approval_by']);
    $q->addWhere('timesheet_config = "timesheet_approval_by"');
    if (!$q->exec()) {
        $AppUI->setMsg(db_error(), UI_MSG_ERROR);
    }

    $q->clear();
    $q->addTable('timesheet_config');
    $q->addUpdate('timesheet_config', 'timesheet_book_year');
    $q->addUpdate('timesheet_value', $_POST['timesheet_book_year']);
    $q->addWhere('timesheet_config = "timesheet_book_year"');
    if (!$q->exec()) {
        $AppUI->setMsg(db_error(), UI_MSG_ERROR);
    }

    $q->clear();
    $q->addTable('timesheet_config');
    $q->addUpdate('timesheet_config', 'timesheet_sort_order');
    $q->addUpdate('timesheet_value', $_POST['timesheet_sort_order']);
    $q->addWhere('timesheet_config = "timesheet_sort_order"');
    if (!$q->exec()) {
        $AppUI->setMsg(db_error(), UI_MSG_ERROR);
    } else {
        $AppUI->setMsg('Timesheet configuration saved', UI_MSG_OK);
    }   
    $q->clear();
    $AppUI->redirect('m=timesheet&a=configure');
}
else {
    // Read values from table
    $q->addQuery('*');
    $q->addTable('timesheet_config');
    if (!$q->exec()) {
        $AppUI->setMsg(db_error(), UI_MSG_ERROR);
    } else {
        $AppUI->setMsg('Timesheet configuration read', UI_MSG_OK);
    }   
    while ($row = $q->fetchRow()) {
        $config[$row['timesheet_config']] = $row['timesheet_value'];
    }
    $q->clear();
}

// Get list of all users
$q->addQuery('user_id, contact_first_name, contact_last_name');
$q->addTable('users');
$q->addTable('contacts');
$q->addWhere('user_contact = contact_id');
$q->addOrder('contact_last_name, contact_first_name');
$q->exec();
$users = array();
while ( $row = $q->fetchRow()) {
  $users[$row['user_id']] = $row['contact_last_name'] . ', ' . $row['contact_first_name'];
}
$q->clear();

/* Sort order */
$order = array();
$order[0] = "Ascending";
$order[1] = "Descending";

// setup the title block
$titleBlock = new w2p_Theme_TitleBlock( 'Configure Timesheet Module', 'timesheet.png', $m, '$m' . '.' . '$a' );
$titleBlock->addCrumb( "?m=system", "system admin" );
$titleBlock->addCrumb( "?m=system&a=viewmods", "modules list" );
$titleBlock->show();
?>
<script language="javascript" type="text/javascript">
function submitFrm( frmName ) {
	eval('document.'+frmName+'.submit();');
}
</script>

<form name="frmTimesheetConfig" method="post" accept-charset="utf-8">
<input type="hidden" name="forcesubmit" value="true" />
<table class="std">
<tr><td>Book Year</td>
    <td>
    <?php
       print "<input type=\"text\" name=\"timesheet_book_year\" id=\"book_year\" value=\"" . $config['timesheet_book_year'] . "\" pattern=\"^\s*\d{4}\" size=4 required />";
    ?>
    </td>
</tr>
<tr><td>Approval by</td>
    <td>
    <select name="timesheet_approval_by" size="1" class="text">
    <?php
      foreach ( $users as $u => $n ) {
        $selected = '';
        if ($u ==  $config['timesheet_approval_by'])
           $selected = ' selected';
        print "<option " . $u . $selected . " value=\"" . $u . "\">" . $users[$u] . "</option>";
        print "\n";
      }
    ?>
    </td>
</tr>
<tr><td>Sort order</td>
    <td>
    <select name="timesheet_sort_order" size="1" class="text">
    <?php
      foreach ( $order as $o => $n ) {
        $selected = '';
        if (strcasecmp($order[$o], $config['timesheet_sort_order']) == 0)
            $selected = ' selected';
        print "<option " . $o .  $selected . " value=\"" . $order[$o] .  "\">" . $order[$o] . "</option>";
        print "\n";
      }
    ?>
    </td>
</tr>
<tr><td align="left">
    <input type="Submit" name="back" value="<?php echo $AppUI->_('back')?>">
    </td>
    <td align="right">
    <input type="Submit" name="submit" value="<?php echo $AppUI->_('submit')?>">
    </td>
</tr>
</table>
</form>

