<?php
/*
 * Copyright (C) 2007-2014, M2X BV
 *
 * Authors: Jean-Paul Saman
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
 *****************************************************************************/

if (!defined('W2P_BASE_DIR')) {
    die('You should not access this file directly.');
}

global $AppUI;

$perms = $AppUI->acl();
if (!$perms->checkModuleItem('timesheet', 'access')) {
    $AppUI->redirect(ACCESS_DENIED);
}

// Which tab do we need to show?
$tab = $AppUI->processIntState('timesheetIdxTab', $_GET, 'tab', 0);

// we check for permissions on this module
$canRead = $perms->checkModule( $m, 'view' );
$canEdit = $perms->checkModule( $m, 'edit' );
$canDelete = $perms->checkModule( $m, 'delete' );

// lock out users that do not have at least readPermission on this module
if (!$canRead) {
    $AppUI->redirect( "m=public&a=access_denied" );
}

// setup the title block with Name, Icon and Help
$titleBlock = new w2p_Theme_TitleBlock( 'Timesheet', 'timesheet.png', $m, "$m.$a" );
$titleBlock->addCell();

// adding the 'add'-Button if user has writePermissions
if ($canEdit) {
    $titleBlock->addCell(
        '<input type="submit" class="button" value="'.$AppUI->_('new timesheet').'">', '',
        '<form action="?m=timesheet&a=addedit" method="post">', '</form>'
    );
}
$titleBlock->show();

// now prepare and show the tabbed information boxes

// The Period default for the timesheets (month,week)
// $period = $AppUI->getPref('TIMESHEET_PERIOD');

// build new tab box object
$tabBox = new CTabBox( "?m=$m", W2P_BASE_DIR . "/modules/$m/", $tab );
$tabBox->add( 'vw_idx_timesheets', 'All timesheets' );
$tabBox->add( 'vw_idx_open', 'Open timesheets' );
$tabBox->add( 'vw_idx_submitted', 'Submitted timesheets' );
$tabBox->add( 'vw_idx_approved', 'Approved timesheets' );
$tabBox->show();

?>
